]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
mailinfo: keep the parsed log message in a strbuf
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
cf419828 11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
893a9764 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
33cfccbb
JK
25# Restrict ourselves to a vanilla subset of protocols; the URLs
26# we get are under control of a remote repository, and we do not
27# want them kicking off arbitrary git-remote-* programs.
28#
29# If the user has already specified a set of allowed protocols,
30# we assume they know what they're doing and use that instead.
31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32export GIT_ALLOW_PROTOCOL
33
5c08dbbd 34command=
ecda0723 35branch=
d27b876b 36force=
d92a3959 37reference=
70c7ac22 38cached=
48bb3033
GP
39recursive=
40init=
1c244f6e 41files=
06b1abb5 42remote=
31ca3ac3 43nofetch=
32948425 44update=
15fc56a8 45prefix=
73b0898d 46custom_name=
275cd184 47depth=
70c7ac22 48
967b2c66
JS
49# The function takes at most 2 arguments. The first argument is the
50# URL that navigates to the submodule origin repo. When relative, this URL
51# is relative to the superproject origin URL repo. The second up_path
52# argument, if specified, is the relative path that navigates
53# from the submodule working tree to the superproject working tree.
54#
55# The output of the function is the origin URL of the submodule.
56#
57# The output will either be an absolute URL or filesystem path (if the
58# superproject origin URL is an absolute URL or filesystem path,
59# respectively) or a relative file system path (if the superproject
60# origin URL is a relative file system path).
61#
62# When the output is a relative file system path, the path is either
63# relative to the submodule working tree, if up_path is specified, or to
64# the superproject working tree otherwise.
f31a522a
ML
65resolve_relative_url ()
66{
98fcf840 67 remote=$(get_default_remote)
8e7e6f39 68 remoteurl=$(git config "remote.$remote.url") ||
4d689320 69 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 70 url="$1"
99b120af 71 remoteurl=${remoteurl%/}
ea640cc6 72 sep=/
967b2c66
JS
73 up_path="$2"
74
75 case "$remoteurl" in
76 *:*|/*)
77 is_relative=
78 ;;
758615e2
JS
79 ./*|../*)
80 is_relative=t
81 ;;
967b2c66
JS
82 *)
83 is_relative=t
758615e2 84 remoteurl="./$remoteurl"
967b2c66
JS
85 ;;
86 esac
87
f31a522a
ML
88 while test -n "$url"
89 do
90 case "$url" in
91 ../*)
92 url="${url#../}"
ea640cc6
TR
93 case "$remoteurl" in
94 */*)
95 remoteurl="${remoteurl%/*}"
96 ;;
97 *:*)
98 remoteurl="${remoteurl%:*}"
99 sep=:
100 ;;
101 *)
758615e2
JS
102 if test -z "$is_relative" || test "." = "$remoteurl"
103 then
104 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
105 else
106 remoteurl=.
107 fi
ea640cc6
TR
108 ;;
109 esac
f31a522a
ML
110 ;;
111 ./*)
112 url="${url#./}"
113 ;;
114 *)
115 break;;
116 esac
117 done
758615e2
JS
118 remoteurl="$remoteurl$sep${url%/}"
119 echo "${is_relative:+${up_path}}${remoteurl#./}"
f31a522a
ML
120}
121
091a6eb0
JK
122# Resolve a path to be relative to another path. This is intended for
123# converting submodule paths when git-submodule is run in a subdirectory
124# and only handles paths where the directory separator is '/'.
125#
126# The output is the first argument as a path relative to the second argument,
127# which defaults to $wt_prefix if it is omitted.
128relative_path ()
129{
130 local target curdir result
131 target=$1
132 curdir=${2-$wt_prefix}
133 curdir=${curdir%/}
134 result=
135
136 while test -n "$curdir"
137 do
138 case "$target" in
139 "$curdir/"*)
140 target=${target#"$curdir"/}
141 break
142 ;;
143 esac
144
145 result="${result}../"
146 if test "$curdir" = "${curdir%/*}"
147 then
148 curdir=
149 else
150 curdir="${curdir%/*}"
151 fi
152 done
153
154 echo "$result$target"
155}
156
a7b3269c
DA
157#
158# Get submodule info for registered submodules
159# $@ = path to limit submodule list
160#
161module_list()
162{
091a6eb0 163 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
be9d0a3a 164 (
74671241 165 git ls-files -z --error-unmatch --stage -- "$@" ||
be9d0a3a
HV
166 echo "unmatched pathspec exists"
167 ) |
fcb06a8d 168 @@PERL@@ -e '
313ee0d6
NMC
169 my %unmerged = ();
170 my ($null_sha1) = ("0" x 40);
be9d0a3a
HV
171 my @out = ();
172 my $unmatched = 0;
74671241 173 $/ = "\0";
313ee0d6 174 while (<STDIN>) {
be9d0a3a
HV
175 if (/^unmatched pathspec/) {
176 $unmatched = 1;
177 next;
178 }
313ee0d6
NMC
179 chomp;
180 my ($mode, $sha1, $stage, $path) =
181 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
182 next unless $mode eq "160000";
183 if ($stage ne "0") {
184 if (!$unmerged{$path}++) {
be9d0a3a 185 push @out, "$mode $null_sha1 U\t$path\n";
313ee0d6
NMC
186 }
187 next;
188 }
be9d0a3a
HV
189 push @out, "$_\n";
190 }
191 if ($unmatched) {
192 print "#unmatched\n";
193 } else {
194 print for (@out);
313ee0d6
NMC
195 }
196 '
a7b3269c
DA
197}
198
be9d0a3a
HV
199die_if_unmatched ()
200{
201 if test "$1" = "#unmatched"
202 then
203 exit 1
204 fi
205}
206
88ce00c3
TK
207#
208# Print a submodule configuration setting
209#
210# $1 = submodule name
211# $2 = option name
212# $3 = default value
213#
214# Checks in the usual git-config places first (for overrides),
215# otherwise it falls back on .gitmodules. This allows you to
216# distribute project-wide defaults in .gitmodules, while still
217# customizing individual repositories if necessary. If the option is
218# not in .gitmodules either, print a default value.
219#
220get_submodule_config () {
221 name="$1"
222 option="$2"
223 default="$3"
224 value=$(git config submodule."$name"."$option")
225 if test -z "$value"
226 then
227 value=$(git config -f .gitmodules submodule."$name"."$option")
228 fi
229 printf '%s' "${value:-$default}"
230}
231
232
941987a5
LH
233#
234# Map submodule path to submodule name
235#
236# $1 = path
237#
238module_name()
239{
537601ac 240 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
64394e3a 241 sm_path="$1"
fe22e542 242 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 243 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 244 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
1e42258a 245 test -z "$name" &&
64394e3a 246 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
6a066230 247 printf '%s\n' "$name"
941987a5 248}
33aa6fff
LH
249
250#
251# Clone a submodule
252#
9adfc1cf
TK
253# $1 = submodule path
254# $2 = submodule name
255# $3 = URL to clone
256# $4 = reference repository to reuse (empty for independent)
257# $5 = depth argument for shallow clones (empty for deep)
258#
23a485e3 259# Prior to calling, cmd_update checks that a possibly existing
ecda0723 260# path is not a git repository.
23a485e3 261# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
262# since it is the location of a new submodule.
263#
33aa6fff
LH
264module_clone()
265{
64394e3a 266 sm_path=$1
73b0898d
JL
267 name=$2
268 url=$3
269 reference="$4"
275cd184 270 depth="$5"
7e60407f
JL
271 quiet=
272 if test -n "$GIT_QUIET"
273 then
274 quiet=-q
275 fi
33aa6fff 276
501770e1
FG
277 gitdir=
278 gitdir_base=
69c30517 279 base_name=$(dirname "$name")
33aa6fff 280
501770e1 281 gitdir=$(git rev-parse --git-dir)
69c30517
JL
282 gitdir_base="$gitdir/modules/$base_name"
283 gitdir="$gitdir/modules/$name"
501770e1
FG
284
285 if test -d "$gitdir"
d92a3959 286 then
64394e3a 287 mkdir -p "$sm_path"
501770e1 288 rm -f "$gitdir/index"
d92a3959 289 else
501770e1 290 mkdir -p "$gitdir_base"
be8779f7
DG
291 (
292 clear_local_git_env
275cd184 293 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
be8779f7
DG
294 --separate-git-dir "$gitdir" "$url" "$sm_path"
295 ) ||
64394e3a 296 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
501770e1 297 fi
ea115a0d 298
6eafa6d0
JL
299 # We already are at the root of the work tree but cd_to_toplevel will
300 # resolve any symlinks that might be present in $PWD
301 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
15b3c82c 302 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
d75219b4
JL
303 # Remove all common leading directories after a sanity check
304 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
305 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
306 fi
307 while test "${a%%/*}" = "${b%%/*}"
308 do
309 a=${a#*/}
310 b=${b#*/}
311 done
312 # Now chop off the trailing '/'s that were added in the beginning
313 a=${a%/}
314 b=${b%/}
315
c5bc42b9 316 # Turn each leading "*/" component into "../"
6a066230
JH
317 rel=$(printf '%s\n' "$b" | sed -e 's|[^/][^/]*|..|g')
318 printf '%s\n' "gitdir: $rel/$a" >"$sm_path/.git"
69c30517 319
6a066230 320 rel=$(printf '%s\n' "$a" | sed -e 's|[^/][^/]*|..|g')
d851ffb9 321 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
33aa6fff
LH
322}
323
862ae6cd
RS
324isnumber()
325{
326 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
327}
328
ecda0723
SV
329#
330# Add a new submodule to the working tree, .gitmodules and the index
331#
ec05df35 332# $@ = repo path
ecda0723
SV
333#
334# optional branch is stored in global branch variable
335#
23a485e3 336cmd_add()
ecda0723 337{
5c08dbbd 338 # parse $args after "submodule ... add".
091a6eb0 339 reference_path=
5c08dbbd
JH
340 while test $# -ne 0
341 do
342 case "$1" in
343 -b | --branch)
344 case "$2" in '') usage ;; esac
345 branch=$2
346 shift
347 ;;
d27b876b
JL
348 -f | --force)
349 force=$1
350 ;;
5c08dbbd 351 -q|--quiet)
2e6a30ef 352 GIT_QUIET=1
5c08dbbd 353 ;;
d92a3959
MT
354 --reference)
355 case "$2" in '') usage ;; esac
091a6eb0 356 reference_path=$2
d92a3959
MT
357 shift
358 ;;
359 --reference=*)
091a6eb0 360 reference_path="${1#--reference=}"
d92a3959 361 ;;
73b0898d
JL
362 --name)
363 case "$2" in '') usage ;; esac
364 custom_name=$2
365 shift
366 ;;
275cd184
FG
367 --depth)
368 case "$2" in '') usage ;; esac
369 depth="--depth=$2"
370 shift
371 ;;
372 --depth=*)
373 depth=$1
374 ;;
5c08dbbd
JH
375 --)
376 shift
377 break
378 ;;
379 -*)
380 usage
381 ;;
382 *)
383 break
384 ;;
385 esac
386 shift
387 done
388
091a6eb0
JK
389 if test -n "$reference_path"
390 then
391 is_absolute_path "$reference_path" ||
392 reference_path="$wt_prefix$reference_path"
393
394 reference="--reference=$reference_path"
395 fi
396
ecda0723 397 repo=$1
64394e3a 398 sm_path=$2
ecda0723 399
64394e3a 400 if test -z "$sm_path"; then
6a066230 401 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
402 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
403 fi
404
496eeeb1 405 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
406 usage
407 fi
408
091a6eb0
JK
409 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
410
ec05df35
ML
411 # assure repo is absolute or relative to parent
412 case "$repo" in
413 ./*|../*)
091a6eb0
JK
414 test -z "$wt_prefix" ||
415 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
416
ec05df35
ML
417 # dereference source url relative to parent's url
418 realrepo=$(resolve_relative_url "$repo") || exit
419 ;;
420 *:*|/*)
421 # absolute url
422 realrepo=$repo
423 ;;
424 *)
497ee872 425 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
426 ;;
427 esac
428
db75ada5
MG
429 # normalize path:
430 # multiple //; leading ./; /./; /../; trailing /
64394e3a 431 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
432 sed -e '
433 s|//*|/|g
434 s|^\(\./\)*||
8196e728 435 s|/\(\./\)*|/|g
db75ada5
MG
436 :start
437 s|\([^/]*\)/\.\./||
438 tstart
439 s|/*$||
440 ')
64394e3a
RJ
441 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
442 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 443
64394e3a 444 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 445 then
6ff875c5 446 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 447\$sm_path
6ff875c5 448Use -f if you really want to add it." >&2
d27b876b
JL
449 exit 1
450 fi
451
73b0898d
JL
452 if test -n "$custom_name"
453 then
454 sm_name="$custom_name"
455 else
456 sm_name="$sm_path"
457 fi
458
d4264ca3 459 # perhaps the path exists and is already a git repo, else clone it
64394e3a 460 if test -e "$sm_path"
d4264ca3 461 then
496eeeb1 462 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 463 then
64394e3a 464 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 465 else
64394e3a 466 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 467 fi
c2f93917 468
d4264ca3 469 else
4b7c286e
JL
470 if test -d ".git/modules/$sm_name"
471 then
472 if test -z "$force"
473 then
474 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
475 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
476 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
477 echo >&2 " $realrepo"
478 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
479 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
480 else
481 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
482 fi
483 fi
d851ffb9
JH
484 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
485 (
486 clear_local_git_env
487 cd "$sm_path" &&
488 # ash fails to wordsplit ${branch:+-b "$branch"...}
489 case "$branch" in
490 '') git checkout -f -q ;;
491 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
492 esac
493 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 494 fi
73b0898d 495 git config submodule."$sm_name".url "$realrepo"
d4264ca3 496
64394e3a
RJ
497 git add $force "$sm_path" ||
498 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 499
73b0898d
JL
500 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
501 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
502 if test -n "$branch"
503 then
504 git config -f .gitmodules submodule."$sm_name".branch "$branch"
505 fi &&
31991b02 506 git add --force .gitmodules ||
64394e3a 507 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
508}
509
19a31f9c
ML
510#
511# Execute an arbitrary command sequence in each checked out
512# submodule
513#
514# $@ = command to execute
515#
516cmd_foreach()
517{
1d5bec8b
JH
518 # parse $args after "submodule ... foreach".
519 while test $# -ne 0
520 do
521 case "$1" in
522 -q|--quiet)
523 GIT_QUIET=1
524 ;;
15fc56a8
JH
525 --recursive)
526 recursive=1
527 ;;
1d5bec8b
JH
528 -*)
529 usage
530 ;;
531 *)
532 break
533 ;;
534 esac
535 shift
536 done
537
f030c96d
ÆAB
538 toplevel=$(pwd)
539
4dca1aa6
BC
540 # dup stdin so that it can be restored when running the external
541 # command in the subshell (and a recursive call to this function)
542 exec 3<&0
543
a7b3269c 544 module_list |
64394e3a 545 while read mode sha1 stage sm_path
19a31f9c 546 do
be9d0a3a 547 die_if_unmatched "$mode"
64394e3a 548 if test -e "$sm_path"/.git
19a31f9c 549 then
091a6eb0
JK
550 displaypath=$(relative_path "$sm_path")
551 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
64394e3a 552 name=$(module_name "$sm_path")
15fc56a8 553 (
64394e3a 554 prefix="$prefix$sm_path/"
74ae1419 555 clear_local_git_env
64394e3a 556 cd "$sm_path" &&
091a6eb0
JK
557 sm_path=$(relative_path "$sm_path") &&
558 # we make $path available to scripts ...
559 path=$sm_path &&
1c4fb136
AK
560 if test $# -eq 1
561 then
562 eval "$1"
563 else
564 "$@"
565 fi &&
15fc56a8
JH
566 if test -n "$recursive"
567 then
568 cmd_foreach "--recursive" "$@"
569 fi
4dca1aa6 570 ) <&3 3<&- ||
091a6eb0 571 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
572 fi
573 done
574}
575
70c7ac22 576#
211b7f19 577# Register submodules in .git/config
70c7ac22
LH
578#
579# $@ = requested paths (default to all)
580#
23a485e3 581cmd_init()
70c7ac22 582{
5c08dbbd
JH
583 # parse $args after "submodule ... init".
584 while test $# -ne 0
585 do
586 case "$1" in
587 -q|--quiet)
2e6a30ef 588 GIT_QUIET=1
5c08dbbd
JH
589 ;;
590 --)
591 shift
592 break
593 ;;
594 -*)
595 usage
596 ;;
597 *)
598 break
599 ;;
600 esac
601 shift
602 done
603
a7b3269c 604 module_list "$@" |
64394e3a 605 while read mode sha1 stage sm_path
70c7ac22 606 do
be9d0a3a 607 die_if_unmatched "$mode"
64394e3a 608 name=$(module_name "$sm_path") || exit
c1c259e2 609
091a6eb0
JK
610 displaypath=$(relative_path "$sm_path")
611
c1c259e2 612 # Copy url setting when it is not set yet
2cd9de3e
JL
613 if test -z "$(git config "submodule.$name.url")"
614 then
615 url=$(git config -f .gitmodules submodule."$name".url)
616 test -z "$url" &&
091a6eb0 617 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
2cd9de3e
JL
618
619 # Possibly a url relative to parent
620 case "$url" in
621 ./*|../*)
622 url=$(resolve_relative_url "$url") || exit
623 ;;
624 esac
625 git config submodule."$name".url "$url" ||
091a6eb0 626 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
c1c259e2 627
091a6eb0 628 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
2cd9de3e 629 fi
70c7ac22 630
2cd9de3e 631 # Copy "update" setting when it is not set yet
ac1fbbda
JH
632 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
633 test -n "$upd" &&
634 test -z "$(git config submodule."$name".update)"
635 then
636 case "$upd" in
efa8fd7e 637 checkout | rebase | merge | none)
ac1fbbda
JH
638 ;; # known modes of updating
639 *)
640 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
641 upd=none
642 ;;
643 esac
644 git config submodule."$name".update "$upd" ||
645 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
646 fi
70c7ac22
LH
647 done
648}
649
cf419828
JL
650#
651# Unregister submodules from .git/config and remove their work tree
652#
653# $@ = requested paths (use '.' to deinit all submodules)
654#
655cmd_deinit()
656{
657 # parse $args after "submodule ... deinit".
658 while test $# -ne 0
659 do
660 case "$1" in
661 -f|--force)
662 force=$1
663 ;;
664 -q|--quiet)
665 GIT_QUIET=1
666 ;;
667 --)
668 shift
669 break
670 ;;
671 -*)
672 usage
673 ;;
674 *)
675 break
676 ;;
677 esac
678 shift
679 done
680
681 if test $# = 0
682 then
683 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
684 fi
685
686 module_list "$@" |
687 while read mode sha1 stage sm_path
688 do
689 die_if_unmatched "$mode"
690 name=$(module_name "$sm_path") || exit
691
091a6eb0
JK
692 displaypath=$(relative_path "$sm_path")
693
cf419828
JL
694 # Remove the submodule work tree (unless the user already did it)
695 if test -d "$sm_path"
696 then
697 # Protect submodules containing a .git directory
698 if test -d "$sm_path/.git"
699 then
091a6eb0 700 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
701 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
702 fi
703
704 if test -z "$force"
705 then
7b294bf4 706 git rm -qn "$sm_path" ||
091a6eb0 707 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 708 fi
7b294bf4 709 rm -rf "$sm_path" &&
091a6eb0
JK
710 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
711 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
712 fi
713
091a6eb0 714 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
715
716 # Remove the .git/config entries (unless the user already did it)
717 if test -n "$(git config --get-regexp submodule."$name\.")"
718 then
719 # Remove the whole section so we have a clean state when
720 # the user later decides to init this submodule again
721 url=$(git config submodule."$name".url)
722 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 723 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
724 fi
725 done
726}
727
70c7ac22 728#
211b7f19 729# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
730#
731# $@ = requested paths (default to all)
732#
23a485e3 733cmd_update()
70c7ac22 734{
5c08dbbd
JH
735 # parse $args after "submodule ... update".
736 while test $# -ne 0
737 do
738 case "$1" in
739 -q|--quiet)
2e6a30ef 740 GIT_QUIET=1
5c08dbbd 741 ;;
be4d2c83 742 -i|--init)
d92a3959 743 init=1
be4d2c83 744 ;;
06b1abb5
TK
745 --remote)
746 remote=1
747 ;;
31ca3ac3 748 -N|--no-fetch)
31ca3ac3
FF
749 nofetch=1
750 ;;
9db31bdf
NMC
751 -f|--force)
752 force=$1
753 ;;
ca2cedba 754 -r|--rebase)
32948425 755 update="rebase"
ca2cedba 756 ;;
d92a3959
MT
757 --reference)
758 case "$2" in '') usage ;; esac
759 reference="--reference=$2"
98dbe63d 760 shift
d92a3959
MT
761 ;;
762 --reference=*)
763 reference="$1"
d92a3959 764 ;;
42b49178 765 -m|--merge)
42b49178
JH
766 update="merge"
767 ;;
b13fd5c1 768 --recursive)
b13fd5c1
JH
769 recursive=1
770 ;;
efc5fb6a
JH
771 --checkout)
772 update="checkout"
773 ;;
275cd184
FG
774 --depth)
775 case "$2" in '') usage ;; esac
776 depth="--depth=$2"
777 shift
778 ;;
779 --depth=*)
780 depth=$1
781 ;;
5c08dbbd
JH
782 --)
783 shift
784 break
785 ;;
786 -*)
787 usage
788 ;;
789 *)
790 break
791 ;;
792 esac
98dbe63d 793 shift
5c08dbbd
JH
794 done
795
d92a3959
MT
796 if test -n "$init"
797 then
798 cmd_init "--" "$@" || return
799 fi
800
1b4735d9 801 cloned_modules=
15ffb7cd
FG
802 module_list "$@" | {
803 err=
64394e3a 804 while read mode sha1 stage sm_path
70c7ac22 805 do
be9d0a3a 806 die_if_unmatched "$mode"
313ee0d6
NMC
807 if test "$stage" = U
808 then
75bf5e60 809 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
313ee0d6
NMC
810 continue
811 fi
64394e3a 812 name=$(module_name "$sm_path") || exit
5be60078 813 url=$(git config submodule."$name".url)
d851ffb9 814 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
815 if ! test -z "$update"
816 then
817 update_module=$update
818 else
819 update_module=$(git config submodule."$name".update)
a2aed08b
TK
820 if test -z "$update_module"
821 then
822 update_module="checkout"
823 fi
efc5fb6a
JH
824 fi
825
091a6eb0
JK
826 displaypath=$(relative_path "$prefix$sm_path")
827
d851ffb9
JH
828 if test "$update_module" = "none"
829 then
091a6eb0 830 echo "Skipping submodule '$displaypath'"
efc5fb6a 831 continue
d851ffb9 832 fi
efc5fb6a 833
211b7f19 834 if test -z "$url"
70c7ac22
LH
835 then
836 # Only mention uninitialized submodules when its
837 # path have been specified
838 test "$#" != "0" &&
091a6eb0 839 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
1c2ef66f 840Maybe you want to use 'update --init'?")"
211b7f19
LH
841 continue
842 fi
843
496eeeb1 844 if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
211b7f19 845 then
d851ffb9 846 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
1b4735d9 847 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
848 subsha1=
849 else
64394e3a 850 subsha1=$(clear_local_git_env; cd "$sm_path" &&
5be60078 851 git rev-parse --verify HEAD) ||
091a6eb0 852 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 853 fi
211b7f19 854
06b1abb5
TK
855 if test -n "$remote"
856 then
857 if test -z "$nofetch"
858 then
859 # Fetch remote before determining tracking $sha1
860 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
861 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
862 fi
863 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
864 sha1=$(clear_local_git_env; cd "$sm_path" &&
865 git rev-parse --verify "${remote_name}/${branch}") ||
866 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
867 fi
868
496eeeb1 869 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 870 then
9db31bdf
NMC
871 subforce=$force
872 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 873 if test -z "$subsha1" && test -z "$force"
b9b378a0 874 then
9db31bdf 875 subforce="-f"
b9b378a0 876 fi
31ca3ac3
FF
877
878 if test -z "$nofetch"
879 then
e5f522d6
JL
880 # Run fetch only if $sha1 isn't present or it
881 # is not reachable from a ref.
64394e3a 882 (clear_local_git_env; cd "$sm_path" &&
f5799e05 883 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 884 test -z "$rev") || git-fetch)) ||
091a6eb0 885 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
31ca3ac3
FF
886 fi
887
1b4735d9
SO
888 # Is this something we just cloned?
889 case ";$cloned_modules;" in
890 *";$name;"*)
891 # then there is no local change to integrate
d851ffb9 892 update_module=checkout ;;
1b4735d9
SO
893 esac
894
877449c1 895 must_die_on_failure=
32948425 896 case "$update_module" in
a2aed08b
TK
897 checkout)
898 command="git checkout $subforce -q"
899 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
900 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
901 ;;
32948425
JH
902 rebase)
903 command="git rebase"
091a6eb0
JK
904 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
905 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 906 must_die_on_failure=yes
32948425 907 ;;
42b49178
JH
908 merge)
909 command="git merge"
091a6eb0
JK
910 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
911 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 912 must_die_on_failure=yes
42b49178 913 ;;
6cb5728c
CP
914 !*)
915 command="${update_module#!}"
b80fa842 916 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
6cb5728c
CP
917 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
918 must_die_on_failure=yes
919 ;;
32948425 920 *)
a2aed08b 921 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 922 esac
70c7ac22 923
64394e3a 924 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 925 then
ff968f03 926 say "$say_msg"
877449c1
JH
927 elif test -n "$must_die_on_failure"
928 then
ff968f03 929 die_with_status 2 "$die_msg"
15ffb7cd 930 else
ff968f03 931 err="${err};$die_msg"
877449c1 932 continue
15ffb7cd 933 fi
70c7ac22 934 fi
b13fd5c1
JH
935
936 if test -n "$recursive"
937 then
75bf5e60
WE
938 (
939 prefix="$prefix$sm_path/"
940 clear_local_git_env
941 cd "$sm_path" &&
36141282 942 eval cmd_update
75bf5e60 943 )
15ffb7cd
FG
944 res=$?
945 if test $res -gt 0
946 then
091a6eb0 947 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
948 if test $res -eq 1
949 then
ff968f03 950 err="${err};$die_msg"
15ffb7cd
FG
951 continue
952 else
ff968f03 953 die_with_status $res "$die_msg"
15ffb7cd
FG
954 fi
955 fi
b13fd5c1 956 fi
70c7ac22 957 done
15ffb7cd
FG
958
959 if test -n "$err"
960 then
961 OIFS=$IFS
962 IFS=';'
963 for e in $err
964 do
965 if test -n "$e"
966 then
967 echo >&2 "$e"
968 fi
969 done
970 IFS=$OIFS
971 exit 1
972 fi
973 }
70c7ac22
LH
974}
975
bffe71f4
EM
976set_name_rev () {
977 revname=$( (
74ae1419 978 clear_local_git_env
bffe71f4 979 cd "$1" && {
5be60078
JH
980 git describe "$2" 2>/dev/null ||
981 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
982 git describe --contains "$2" 2>/dev/null ||
983 git describe --all --always "$2"
bffe71f4
EM
984 }
985 ) )
986 test -z "$revname" || revname=" ($revname)"
987}
28f9af5d
PY
988#
989# Show commit summary for submodules in index or working tree
990#
991# If '--cached' is given, show summary between index and given commit,
992# or between working tree and given commit
993#
994# $@ = [commit (default 'HEAD'),] requested paths (default all)
995#
996cmd_summary() {
f2dc06a3 997 summary_limit=-1
d0f64dd4 998 for_status=
1c244f6e 999 diff_cmd=diff-index
f2dc06a3 1000
28f9af5d
PY
1001 # parse $args after "submodule ... summary".
1002 while test $# -ne 0
1003 do
1004 case "$1" in
1005 --cached)
1006 cached="$1"
1007 ;;
1c244f6e
JL
1008 --files)
1009 files="$1"
1010 ;;
d0f64dd4
PY
1011 --for-status)
1012 for_status="$1"
1013 ;;
f2dc06a3 1014 -n|--summary-limit)
862ae6cd
RS
1015 summary_limit="$2"
1016 isnumber "$summary_limit" || usage
f2dc06a3
PY
1017 shift
1018 ;;
862ae6cd
RS
1019 --summary-limit=*)
1020 summary_limit="${1#--summary-limit=}"
1021 isnumber "$summary_limit" || usage
1022 ;;
28f9af5d
PY
1023 --)
1024 shift
1025 break
1026 ;;
1027 -*)
1028 usage
1029 ;;
1030 *)
1031 break
1032 ;;
1033 esac
1034 shift
1035 done
bffe71f4 1036
f2dc06a3
PY
1037 test $summary_limit = 0 && return
1038
3deea89c 1039 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
1040 then
1041 head=$rev
caa9c3ca 1042 test $# = 0 || shift
496eeeb1 1043 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 1044 then
14e940d7
JH
1045 # before the first commit: compare with an empty tree
1046 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 1047 test -z "$1" || shift
28f9af5d 1048 else
3deea89c 1049 head="HEAD"
28f9af5d
PY
1050 fi
1051
1c244f6e
JL
1052 if [ -n "$files" ]
1053 then
1054 test -n "$cached" &&
465d6a00 1055 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
1056 diff_cmd=diff-files
1057 head=
1058 fi
1059
28f9af5d 1060 cd_to_toplevel
091a6eb0 1061 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 1062 # Get modified modules cared by user
18076502 1063 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 1064 sane_egrep '^:([0-7]* )?160000' |
2be94509 1065 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
1066 do
1067 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
1068 if test "$status" = D || test "$status" = T
1069 then
6a066230 1070 printf '%s\n' "$sm_path"
496eeeb1
EP
1071 continue
1072 fi
927b26f8 1073 # Respect the ignore setting for --for-status.
1074 if test -n "$for_status"
1075 then
1076 name=$(module_name "$sm_path")
1077 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 1078 test $status != A && test $ignore_config = all && continue
927b26f8 1079 fi
28f9af5d 1080 # Also show added or modified modules which are checked out
2be94509 1081 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 1082 printf '%s\n' "$sm_path"
28f9af5d
PY
1083 done
1084 )
1cb639e6 1085
d0f64dd4
PY
1086 test -z "$modules" && return
1087
18076502 1088 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 1089 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
1090 cut -c2- |
1091 while read mod_src mod_dst sha1_src sha1_dst status name
1092 do
1093 if test -z "$cached" &&
1094 test $sha1_dst = 0000000000000000000000000000000000000000
1095 then
1096 case "$mod_dst" in
1097 160000)
1098 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1099 ;;
1100 100644 | 100755 | 120000)
1101 sha1_dst=$(git hash-object $name)
1102 ;;
1103 000000)
1104 ;; # removed
1105 *)
1106 # unexpected type
6ff875c5 1107 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
1108 continue ;;
1109 esac
1110 fi
1111 missing_src=
1112 missing_dst=
1113
1114 test $mod_src = 160000 &&
30353a40 1115 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
1116 missing_src=t
1117
1118 test $mod_dst = 160000 &&
30353a40 1119 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 1120 missing_dst=t
bffe71f4 1121
091a6eb0
JK
1122 display_name=$(relative_path "$name")
1123
1cb639e6
PY
1124 total_commits=
1125 case "$missing_src,$missing_dst" in
1126 t,)
091a6eb0 1127 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
1128 ;;
1129 ,t)
091a6eb0 1130 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
1131 ;;
1132 t,t)
091a6eb0 1133 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
1134 ;;
1135 *)
1136 errmsg=
1137 total_commits=$(
496eeeb1 1138 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
1139 then
1140 range="$sha1_src...$sha1_dst"
1141 elif test $mod_src = 160000
1142 then
1143 range=$sha1_src
1144 else
1145 range=$sha1_dst
1146 fi
1147 GIT_DIR="$name/.git" \
b0e621ad 1148 git rev-list --first-parent $range -- | wc -l
1cb639e6 1149 )
eed35595 1150 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
1151 ;;
1152 esac
1153
1154 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1155 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1156 if test $status = T
1157 then
b3e73449
ÆAB
1158 blob="$(gettext "blob")"
1159 submodule="$(gettext "submodule")"
1cb639e6
PY
1160 if test $mod_dst = 160000
1161 then
091a6eb0 1162 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 1163 else
091a6eb0 1164 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
1165 fi
1166 else
091a6eb0 1167 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
1168 fi
1169 if test -n "$errmsg"
1170 then
1171 # Don't give error msg for modification whose dst is not submodule
1172 # i.e. deleted or changed to blob
1173 test $mod_dst = 160000 && echo "$errmsg"
1174 else
496eeeb1 1175 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 1176 then
f2dc06a3
PY
1177 limit=
1178 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 1179 GIT_DIR="$name/.git" \
f2dc06a3 1180 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
1181 --first-parent $sha1_src...$sha1_dst
1182 elif test $mod_dst = 160000
1183 then
1184 GIT_DIR="$name/.git" \
1185 git log --pretty='format: > %s' -1 $sha1_dst
1186 else
1187 GIT_DIR="$name/.git" \
1188 git log --pretty='format: < %s' -1 $sha1_src
1189 fi
1190 echo
1191 fi
1192 echo
3ba7407b 1193 done
28f9af5d 1194}
70c7ac22 1195#
941987a5 1196# List all submodules, prefixed with:
70c7ac22
LH
1197# - submodule not initialized
1198# + different revision checked out
1199#
1200# If --cached was specified the revision in the index will be printed
1201# instead of the currently checked out revision.
1202#
1203# $@ = requested paths (default to all)
1204#
23a485e3 1205cmd_status()
70c7ac22 1206{
5c08dbbd
JH
1207 # parse $args after "submodule ... status".
1208 while test $# -ne 0
1209 do
1210 case "$1" in
1211 -q|--quiet)
2e6a30ef 1212 GIT_QUIET=1
5c08dbbd
JH
1213 ;;
1214 --cached)
1215 cached=1
1216 ;;
64b19ffe
JH
1217 --recursive)
1218 recursive=1
1219 ;;
5c08dbbd
JH
1220 --)
1221 shift
1222 break
1223 ;;
1224 -*)
1225 usage
1226 ;;
1227 *)
1228 break
1229 ;;
1230 esac
1231 shift
1232 done
1233
a7b3269c 1234 module_list "$@" |
64394e3a 1235 while read mode sha1 stage sm_path
70c7ac22 1236 do
be9d0a3a 1237 die_if_unmatched "$mode"
64394e3a 1238 name=$(module_name "$sm_path") || exit
5be60078 1239 url=$(git config submodule."$name".url)
091a6eb0 1240 displaypath=$(relative_path "$prefix$sm_path")
313ee0d6
NMC
1241 if test "$stage" = U
1242 then
1243 say "U$sha1 $displaypath"
1244 continue
1245 fi
496eeeb1
EP
1246 if test -z "$url" ||
1247 {
1248 ! test -d "$sm_path"/.git &&
1249 ! test -f "$sm_path"/.git
1250 }
70c7ac22 1251 then
64b19ffe 1252 say "-$sha1 $displaypath"
70c7ac22
LH
1253 continue;
1254 fi
64394e3a 1255 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1256 then
b545cd15 1257 set_name_rev "$sm_path" "$sha1"
64b19ffe 1258 say " $sha1 $displaypath$revname"
70c7ac22
LH
1259 else
1260 if test -z "$cached"
1261 then
64394e3a 1262 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1263 fi
b545cd15 1264 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1265 say "+$sha1 $displaypath$revname"
1266 fi
1267
1268 if test -n "$recursive"
1269 then
1270 (
1271 prefix="$displaypath/"
74ae1419 1272 clear_local_git_env
64394e3a 1273 cd "$sm_path" &&
e15bec0e 1274 eval cmd_status
64b19ffe 1275 ) ||
64394e3a 1276 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1277 fi
1278 done
1279}
2327f61e
DA
1280#
1281# Sync remote urls for submodules
1282# This makes the value for remote.$remote.url match the value
1283# specified in .gitmodules.
1284#
1285cmd_sync()
1286{
1287 while test $# -ne 0
1288 do
1289 case "$1" in
1290 -q|--quiet)
2e6a30ef 1291 GIT_QUIET=1
2327f61e
DA
1292 shift
1293 ;;
82f49f29
PH
1294 --recursive)
1295 recursive=1
1296 shift
1297 ;;
2327f61e
DA
1298 --)
1299 shift
1300 break
1301 ;;
1302 -*)
1303 usage
1304 ;;
1305 *)
1306 break
1307 ;;
1308 esac
1309 done
1310 cd_to_toplevel
1311 module_list "$@" |
64394e3a 1312 while read mode sha1 stage sm_path
2327f61e 1313 do
be9d0a3a 1314 die_if_unmatched "$mode"
64394e3a 1315 name=$(module_name "$sm_path")
2327f61e 1316 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1317
1318 # Possibly a url relative to parent
1319 case "$url" in
1320 ./*|../*)
967b2c66
JS
1321 # rewrite foo/bar as ../.. to find path from
1322 # submodule work tree to superproject work tree
6a066230 1323 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1324 # guarantee a trailing /
1325 up_path=${up_path%/}/ &&
1326 # path from submodule work tree to submodule origin repo
1327 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1328 # path from superproject work tree to submodule origin repo
1329 super_config_url=$(resolve_relative_url "$url") || exit
1330 ;;
1331 *)
1332 sub_origin_url="$url"
1333 super_config_url="$url"
baede9f8
JH
1334 ;;
1335 esac
1336
ccee6086 1337 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1338 then
091a6eb0
JK
1339 displaypath=$(relative_path "$prefix$sm_path")
1340 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1341 git config submodule."$name".url "$super_config_url"
ccee6086 1342
64394e3a 1343 if test -e "$sm_path"/.git
ccee6086
JH
1344 then
1345 (
1346 clear_local_git_env
64394e3a 1347 cd "$sm_path"
ccee6086 1348 remote=$(get_default_remote)
967b2c66 1349 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1350
1351 if test -n "$recursive"
1352 then
1353 prefix="$prefix$sm_path/"
1354 eval cmd_sync
1355 fi
ccee6086
JH
1356 )
1357 fi
2327f61e
DA
1358 fi
1359 done
1360}
70c7ac22 1361
5c08dbbd
JH
1362# This loop parses the command line arguments to find the
1363# subcommand name to dispatch. Parsing of the subcommand specific
1364# options are primarily done by the subcommand implementations.
1365# Subcommand specific options such as --branch and --cached are
1366# parsed here as well, for backward compatibility.
1367
1368while test $# != 0 && test -z "$command"
70c7ac22
LH
1369do
1370 case "$1" in
cf419828 1371 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1372 command=$1
70c7ac22
LH
1373 ;;
1374 -q|--quiet)
2e6a30ef 1375 GIT_QUIET=1
70c7ac22 1376 ;;
ecda0723
SV
1377 -b|--branch)
1378 case "$2" in
1379 '')
1380 usage
1381 ;;
1382 esac
1383 branch="$2"; shift
1384 ;;
70c7ac22 1385 --cached)
28f9af5d 1386 cached="$1"
70c7ac22
LH
1387 ;;
1388 --)
1389 break
1390 ;;
1391 -*)
1392 usage
1393 ;;
1394 *)
1395 break
1396 ;;
1397 esac
1398 shift
1399done
1400
5c08dbbd 1401# No command word defaults to "status"
af9c9f97
RR
1402if test -z "$command"
1403then
1404 if test $# = 0
1405 then
1406 command=status
1407 else
1408 usage
1409 fi
1410fi
5c08dbbd
JH
1411
1412# "-b branch" is accepted only by "add"
1413if test -n "$branch" && test "$command" != add
1414then
ecda0723 1415 usage
5c08dbbd
JH
1416fi
1417
28f9af5d 1418# "--cached" is accepted only by "status" and "summary"
496eeeb1 1419if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1420then
70c7ac22 1421 usage
5c08dbbd
JH
1422fi
1423
1424"cmd_$command" "$@"